/* 
 * Copyright (C) 2008-2009 by Emmanuel Azencot under the GNU LGPL
 * license version 2.0 or 2.1.  You should have received a copy of the
 * LGPL license along with this library if you did not you can find it
 * at http://www.gnu.org/.
 */
#include <stdio.h>
#include <errno.h>

#ifdef raise
  #undef raise
#endif
#define raise(action, error_no, fmt, args...) { \
   if ( (error_no) ) { \
      errno = (EXCP_MOD) | (error_no); \
      action; \
   } }

#ifdef relay
  #undef relay
#endif
#define relay(action, fmt, args...) { \
   if ( errno ) { \
      action; \
   } }
#ifdef excp_assert
  #undef excp_assert
#endif
#define excp_assert(action, error_no, expression) { \
   if ( !(expression) ) { \
      (errno = (EXCP_MOD) | (error_no));\
      action; \
   } \
}

