/* 
 * Copyright (C) 2008-2009 by Emmanuel Azencot under the GNU LGPL
 * license version 2.0 or 2.1.  You should have received a copy of the
 * LGPL license along with this library if you did not you can find it
 * at http://www.gnu.org/.
 */
/*
 * Azencot : Sat Dec  6 02:31:40 CET 2008
 *  Creation
 */
#ifndef _RING_ALLOC_H_ /* [ */
#define _RING_ALLOC_H_

#define RING_ALLOC_VERSION 1
#define RING_ALLOC_RELEASE 0

typedef struct s_mempool *to_mempool;

to_mempool f_mempool_init(size_t size, void *start);
struct s_mempool_info {
   short version;
   short  release;
   struct { int stats:1; int chk_pool:1; int chk_blk:1; } options;
   size_t pool_head_size;
   size_t block_head_size;
};
int f_mempool_info(struct s_mempool_info *info);

struct s_mempool_stats {
   struct {
      struct { size_t alloc, free; } blocks, bytes;
   } instant, cumul;
};
int f_mempool_stats(to_mempool mempool, struct s_mempool_stats *stats);

void *f_mempool_malloc(to_mempool mempool, size_t size);

int f_mempool_free(to_mempool mempool, void *mem);

void *f_mempool_realloc(to_mempool mempool, void *mem, size_t size);

void *f_mempool_calloc(to_mempool mempool, size_t nmemb, size_t size);

#endif /* ] _RING_ALLOC_H_ */
