/* 
 * Copyright (C) 2008-2009 by Emmanuel Azencot under the GNU LGPL
 * license version 2.0 or 2.1.  You should have received a copy of the
 * LGPL license along with this library if you did not you can find it
 * at http://www.gnu.org/.
 */
/*
 * Azencot : Sat Dec  6 11:14:08 CET 2008
 *  Creation
 */
#include <stdio.h>
#include <errno.h>
#include <assert.h>

#include "ring.h"
#include "ring_alloc.h"

unsigned char region[0x20000];

int main(int argc, char *argv[]) {
   to_mempool mempool;
   struct s_mempool_info info;
   struct s_mempool_stats stats;
   void *mem;

{
   void *mem[6];
   int size, i;
   assert ( !f_mempool_info(&info) );
   size = info.pool_head_size + 5*(info.pool_head_size +40);
   assert( (mempool = f_mempool_init(size, region)) ) ;
   for ( i = 0; i < 5; ++i ) {
      assert( (mem[i] = f_mempool_malloc(mempool, 40)) );
   }
   assert( !f_mempool_free(mempool, mem[1]) );
   assert( !f_mempool_free(mempool, mem[3]) );
   assert( !f_mempool_free(mempool, mem[5]) );
   assert( !f_mempool_free(mempool, mem[0]) );
   assert( !f_mempool_free(mempool, mem[2]) );
   assert( !f_mempool_free(mempool, mem[4]) );
}
   assert( !(mempool = f_mempool_init(0, region)) && errno == ENOMEM) ;
   assert( !(mempool = f_mempool_init(16, region)) && errno == ENOMEM) ;
   assert( !(mempool = f_mempool_init(200, 0)) && errno == EFAULT) ;
   
   assert ( !f_mempool_info(&info) );
   assert( info.options.stats && info.options.chk_pool && info.options.chk_blk );
   assert( info.pool_head_size >= 3*sizeof(void *) );
   assert( info.block_head_size >= 1*sizeof(void *) );
// printf("pool_head_size = %d, block_head_size = %d\n", info.pool_head_size, info.block_head_size);
   assert( !(mempool = f_mempool_init(info.pool_head_size +info.block_head_size -1, region)) && errno == ENOMEM) ;
   assert( (mempool = f_mempool_init(info.pool_head_size +info.block_head_size, region)) ) ;
   assert( f_mempool_stats(mempool, &stats) == 0 ) ;
   assert( (mem = f_mempool_malloc(mempool, 0)) );
   assert( f_mempool_free(mempool, (void *)0x30) == -1 && errno == ENOTDIR);
   errno = 0; assert( !f_mempool_free(mempool, 0) && errno == 0);
   assert( !f_mempool_free(mempool, mem) );
   assert( f_mempool_free(mempool, mem) == -1 && errno == ENOENT);
   return 0;
}
